From: Kanchan Joshi <joshi.k@samsung.com>
To: shinichiro.kawasaki@wdc.com
Cc: linux-nvme@lists.infradead.org, linux-block@vger.kernel.org,
mcgrof@kernel.org, Kanchan Joshi <joshi.k@samsung.com>
Subject: [PATCH blktests 2/2] nvme/047: add test for uring-passthrough
Date: Fri, 31 Mar 2023 09:14:14 +0530 [thread overview]
Message-ID: <20230331034414.42024-3-joshi.k@samsung.com> (raw)
In-Reply-To: <20230331034414.42024-1-joshi.k@samsung.com>
User can communicate to NVMe char device (/dev/ngXnY) using the
uring-passthrough interface. This test exercises some of these
communication pathways, using the 'io_uring_cmd' ioengine of fio.
Signed-off-by: Kanchan Joshi <joshi.k@samsung.com>
---
tests/nvme/047 | 46 ++++++++++++++++++++++++++++++++++++++++++++++
tests/nvme/047.out | 2 ++
2 files changed, 48 insertions(+)
create mode 100755 tests/nvme/047
create mode 100644 tests/nvme/047.out
diff --git a/tests/nvme/047 b/tests/nvme/047
new file mode 100755
index 0000000..a0cc8b2
--- /dev/null
+++ b/tests/nvme/047
@@ -0,0 +1,46 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-3.0+
+# Copyright (C) 2023 Kanchan Joshi, Samsung Electronics
+# Test exercising uring passthrough IO on nvme char device
+
+. tests/nvme/rc
+
+DESCRIPTION="basic test for uring-passthrough io on /dev/ngX"
+QUICK=1
+
+requires() {
+ _nvme_requires
+ _have_kver 6 1
+ _have_fio_ver 3 33
+}
+
+test_device() {
+ echo "Running ${TEST_NAME}"
+ local ngdev=${TEST_DEV/nvme/ng}
+ local common_args=(
+ --size=1M
+ --filename="$ngdev"
+ --bs=4k
+ --rw=randread
+ --numjobs=2
+ --iodepth=8
+ --name=randread
+ --ioengine=io_uring_cmd
+ --cmd_type=nvme
+ --time_based
+ --runtime=2
+ )
+ #plain read test
+ _run_fio "${common_args[@]}"
+
+ #read with iopoll
+ _run_fio "${common_args[@]}" --hipri
+
+ #read with fixedbufs
+ _run_fio "${common_args[@]}" --fixedbufs
+
+ #if ! _run_fio "${common_args[@]}" >> "${FULL}" 2>&1; then
+ # echo "Error: uring-passthru read failed"
+ #fi
+ echo "Test complete"
+}
diff --git a/tests/nvme/047.out b/tests/nvme/047.out
new file mode 100644
index 0000000..915d0a2
--- /dev/null
+++ b/tests/nvme/047.out
@@ -0,0 +1,2 @@
+Running nvme/047
+Test complete
--
2.25.1
next prev parent reply other threads:[~2023-03-31 3:45 UTC|newest]
Thread overview: 7+ messages / expand[flat|nested] mbox.gz Atom feed top
[not found] <CGME20230331034524epcas5p31c3793c0c2071846ed82ff0f1369e90d@epcas5p3.samsung.com>
2023-03-31 3:44 ` [PATCH blktests 0/2] nvme uring-passthrough test Kanchan Joshi
2023-03-31 3:44 ` [PATCH blktests 1/2] common,fio: helper for version check Kanchan Joshi
2023-03-31 3:44 ` Kanchan Joshi [this message]
2023-04-07 8:07 ` [PATCH blktests 2/2] nvme/047: add test for uring-passthrough Shin'ichiro Kawasaki
2023-04-10 0:43 ` Shin'ichiro Kawasaki
2023-04-10 12:43 ` Kanchan Joshi
2023-04-11 1:35 ` Shin'ichiro Kawasaki
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20230331034414.42024-3-joshi.k@samsung.com \
--to=joshi.k@samsung.com \
--cc=linux-block@vger.kernel.org \
--cc=linux-nvme@lists.infradead.org \
--cc=mcgrof@kernel.org \
--cc=shinichiro.kawasaki@wdc.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox